﻿
using SpotnetWatchdog.Utils;
using GalaSoft.MvvmLight.Messaging;
namespace SpotnetWatchdog.ViewModels
{
    class MainWindowViewModel : ViewModelBase
    {
        #region Fields

        private bool _showWatchResults;

        #endregion

        #region Constructors

        public MainWindowViewModel(bool showWatchResults)
        {
            WatchItems = new WatchItemsViewModel();
            WatchResults = new WatchResultsViewModel(showWatchResults);

            ShowWatchResults = showWatchResults;

            RegisterNotificationMessages();
        }

        #endregion

        #region Public Properties

        /// <summary>
        /// Gets or sets ShowWatchResults
        /// </summary>
        public bool ShowWatchResults
        {
            get { return _showWatchResults; }
            set
            {
                if (_showWatchResults != value)
                {
                    _showWatchResults = value;
                    RaisePropertyChanged("ShowWatchResults");
                }
            }
        }

        public ViewModelBase WatchItems { get; private set; }

        public ViewModelBase WatchResults { get; private set; }

        #endregion

        #region Notification Messages

        private void RegisterNotificationMessages()
        {
            //show watch results tab
            Messenger.Default.Register<NewSpotsNotificationMessage>(this,
                (nm) => { ShowWatchResults = true; });
        }

        #endregion
    }
}
