﻿using System.ComponentModel;
using SpotnetWatchdog.Utils;

namespace SpotnetWatchdog.ViewModels
{
    /// <summary>
    /// Base class for view models
    /// </summary>
    class ViewModelBase : GalaSoft.MvvmLight.ViewModelBase
    {
        #region Fields

        private bool _isBusy;

        #endregion

        #region Constructors

        public ViewModelBase()
        {
            MessageDialog = new MessageDialog();
        }
        
        #endregion

        #region Public Properties

        /// <summary>
        /// Gets or sets IsBusy
        /// </summary>
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    RaisePropertyChanged("IsBusy");
                }
            }
        }

        /// <summary>
        /// Object for showing messages
        /// </summary>
        public IMessageDialog MessageDialog { get; set; }

        #endregion
    }
}
